<template>
  <div class="app-container" ref="appContainer">
    <ServerPropTable :loading="loading" @selection-change="selectionChange" :columns="column" :data="list" @reset="reset"
      @onSubmit="onSubmit">
      <template v-slot:btn>
        <div style="display: flex; justify-content: flex-end">
          <el-button type="primary" @click="add"
          ><el-icon><plus /></el-icon> 添加</el-button>
          <el-button type="danger" @click="batchDelete"><el-icon>
              <delete />
            </el-icon>删除</el-button>
        </div>
      </template>
      <template v-slot:codeType="scope">{{getStateLabel(scope.row.codeType)}}</template>
      <template v-slot:operation="scope">
        <el-button type="primary" size="small" icon="Edit" @click="edit(scope.row)">
          编辑
        </el-button>
        <el-button @click="del(scope.row)" type="danger" size="small" icon="Delete">
          删除
        </el-button>
      </template>
    </ServerPropTable>

    <el-dialog v-model="dialogVisible" :title='title' width="50%">
      <el-form ref="ruleFormRef" :model="ruleForm" :rules="rules" label-width="120px" class="demo-ruleForm"
        :size="formSize">
        <el-form-item label="礼包码" prop="code">
          <el-input readonly :value="ruleForm.code" />
        </el-form-item>
        <el-form-item label="礼包类型" prop="codeType">
          <el-select v-model="ruleForm.codeType" placeholder="礼包类型">
            <el-option label="一次性" value="0" />
            <el-option label="通用" value="1" />
          </el-select>
        </el-form-item>
        <el-form-item label="礼包道具" prop="itemInfo">
          <el-input v-model="ruleForm.itemInfo" />
        </el-form-item>
        <el-form-item label="礼包生效时间" required>
          <el-col :span="11">
            <el-form-item prop="validTime">
              <el-date-picker
                  v-model="ruleForm.validTime"
                  type="datetime"
                  placeholder="选择开始时间"
                  style="width: 100%"
              />
            </el-form-item>
          </el-col>
          <el-col class="text-center" :span="2" style="text-align: center">
            <span class="text-gray-500">-</span>
          </el-col>
          <el-col :span="11">
            <el-form-item prop="invalidTime">
              <el-date-picker v-model="ruleForm.invalidTime"  type="datetime" placeholder="选择结束时间" style="width: 100%" />
            </el-form-item>
          </el-col>
        </el-form-item>

      </el-form>
      <template #footer>
        <span class="dialog-footer">
          <el-button @click="dialogVisible = false">取消</el-button>
          <el-button type="primary" @click="handleClose(ruleFormRef)">确定</el-button>
        </span>
      </template>
    </el-dialog>
  </div>
</template>
<script lang="ts" setup name="comprehensive">
import { ref, reactive, onMounted, nextTick } from 'vue'
import * as dayjs from 'dayjs'
import { ElMessage, ElMessageBox } from 'element-plus'
import type { FormInstance } from 'element-plus'
const loading = ref(true)
const appContainer = ref(null)
import ServerPropTable from '@/components/Table/ServerPropTable/index.vue'
const data = []
for (let i = 0; i < 100; i++) {
  data.push({
    code: 'Code_' + i,
    codeType: i % 2,
    itemInfo:'1001-100,1002-200',
    validTime: '2023-8-18 10:00:00',
    invalidTime: '2023-9-18 10:00:00',
    usePlayer: '1000001',
  })
}
const column = [
  { type: 'selection', width: 60, fixed: 'left' },
  { name: 'code', label: '礼包码', inSearch: true, valueType: 'input', width: 80 },
  {
    name: 'codeType',
    label: '礼包类型',
    slot: true,
    inSearch: true,
    options: [
      {
        value: 0,
        label: '一次性',
      },
      {
        value: 1,
        label: '通用',
      },
    ],
    valueType: 'select',
  },
  { name: 'itemInfo', label: '礼包道具'},
  { name: 'validTime', label: '礼包生效时间'},
  { name: 'invalidTime', label: '礼包失效时间'},
  { name: 'usePlayer', label: '使用的玩家', inSearch: true, valueType: 'input'},
  { name: 'operation', slot: true, fixed: 'right', width: 200, label: '操作' },
]

const getStateLabel = (val) => {
  if (val == 0) {
    return '一次性'
  } else if (val == 1) {
    return '通用'
  }
}

const list = ref(data)

const formSize = ref('default')
const ruleFormRef = ref<FormInstance>()
const ruleForm = reactive({
  weight: 0,
  state: null,
  openTime: null
})

const rules = reactive({
  code: [
    {
      required: true,
      message: '请输入礼包码',
      trigger: 'change',
    }
  ],
  codeType: [
    {
      required: true,
      message: '请选择礼包类型',
      trigger: 'change',
    },
  ],
  itemInfo: [
    {
      required: true,
      message: '请输入礼包道具',
      trigger: 'change',
    },
  ],
  validTime : [
    {
      required: true,
      type: 'date',
      message: '请选择礼包生效时间',
      trigger: 'change',
    },
  ],
  invalidTime: [
    {
      required: true,
      type: 'date',
      message: '请选择礼包失效时间',
      trigger: 'change',
    },
  ],
})

const dialogVisible = ref(false)
const rowObj = ref({})
const selectObj = ref([])
const title = ref('编辑')

const handleClose = async (done: () => void) => {
  await ruleFormRef.value.validate((valid, fields) => {
    if (valid) {
      list.value.forEach((item) => {
        if (item.id === rowObj.value.id) {
          item.weight = ruleForm.weight
          item.state = ruleForm.state
          item.openTime = ruleForm.openTime
        }
      })
      dialogVisible.value = false
      console.log('submit!', ruleForm.weight, ruleForm.state)
    } else {
      console.log('error submit!', fields)
    }
  })
}

const add = () => {
  title.value = '新增'
  dialogVisible.value = true
}

const batchDelete = () => {
  if (!selectObj.value.length) {
    return ElMessage.error('未选中任何行')
  }
  ElMessageBox.confirm('你确定要删除选中项吗?', '温馨提示', {
    confirmButtonText: '确定',
    cancelButtonText: '取消',
    type: 'warning',
    draggable: true,
  })
    .then(() => {
      ElMessage.success('模拟删除成功')
      list.value = list.value.concat([])
    })
    .catch(() => { })
}
const selectionChange = (val) => {
  selectObj.value = val
}

const edit = (row) => {
  rowObj.value = row
  dialogVisible.value = true
  ruleForm.id = row.id
  ruleForm.weight = row.weight
  ruleForm.state = row.state
  ruleForm.openTime = row.openTime
}

const del = (row) => {
  console.log('row==', row)
  ElMessageBox.confirm('你确定要删除当前项吗?', '温馨提示', {
    confirmButtonText: '确定',
    cancelButtonText: '取消',
    type: 'warning',
    draggable: true,
  })
    .then(() => {
      list.value = list.value.filter((item) => item.id !== row.id)
      ElMessage.success('删除成功')
      loading.value = true
      setTimeout(() => {
        loading.value = false
      }, 500)
    })
    .catch(() => { })
}

const reset = () => {
  loading.value = true
  setTimeout(() => {
    loading.value = false
  }, 500)
  ElMessage.success('触发重置方法')
}

const onSubmit = (val) => {
  console.log('val===', val)
  ElMessage.success('触发查询方法')
  loading.value = true
  setTimeout(() => {
    loading.value = false
  }, 500)
}

const onUpdate = (val) => {
  console.log('val===', val)
  ElMessage.success('触发修改方法')
  loading.value = true
  setTimeout(() => {
    loading.value = false
  }, 500)
}

const getHeight = () => {

}

onMounted(() => {
  nextTick(() => {
    // let data = appContainer.value.
  })
  setTimeout(() => {
    loading.value = false
  }, 500)
})
</script>

<style scoped>
.edit-input {
  padding-right: 100px;
}

.app-container {
  flex: 1;
  display: flex;
  width: 100%;
  padding: 16px;
  box-sizing: border-box;
}

.cancel-btn {
  position: absolute;
  right: 15px;
  top: 10px;
}
</style>
